/*  rmFxIcalMail.js   //gW -  RmFx iCal   rev.2008-01
 
 * SEND:	Reminderfox events stored in the users list can be send
 * 			using the TB/mail facility.
 * 			Sending modes are:
 * 			- just send one or more events from the list to another
 * 			  user, this is the METHOD:PUBLISH. 
 * 			- send one event as "Invitation" or "Schedule", this is 
 * 			  based on RFC2446 (iTIP)
 * 			  Current implementation supports: 
 * 			  -- METHOD: PUBLISH, REQUEST, REPLY
 * 
 * RECEIVE:	ICS-file with RFC2445 (iCalendar) data is read and added
 * 			to the Reminderfox.ics file.
 * 			The ICS-data can be part of the body or attached as
 * 			a ICS file.
 * 			The data is interpreted in conformance to RFC2446 
 * 			and supports:
 * 			  -- METHOD: PUBLISH, REQUEST, REPLY
 * 
 *  NOTE:	Both RFC's are not covered in all aspects, for actual 
 * 			please refer to 'RmFx_iCal_iTIP_Implementation.pdf'
*/
var rmFx_mailApplication = false;	
var rmFx_fromMailadr;
var rmFx_iCalMETHOD;  
var rmFx_iCalAttendees;
var rmFx_iCalOrganizer;


// -------------- RECEIVE iCal ---------------------------
function rmFxGetiCalMailed() {  
/* --------------------------------------------
	1. reads data from 'msgHdr'
	2. reads mail ICS-data from 
				(a.)  mail-inline (body)   
		**OR**	(b.)  first attachment including a iCal data set
*/
	var ret = "\n"; 		/*   compatiblity with other OSes like Apple, Linux ?????? $$$2do */

	// --- get some msgHeader Infos ------	
	var msgHdr = gDBView.hdrForFirstSelectedMessage;
    // subject
    var rmFxSummary = msgHdr.mime2DecodedSubject;
    // from
    var rmFxFrom =  msgHdr.mime2DecodedAuthor;
    rmFx_fromMailadr =rmFxFrom;				// need for processing eg REPLY
    
    // recipients
    var rmFxTo = msgHdr.mime2DecodedRecipients;
    // messageID
    var rmFxMessageId =  msgHdr.messageId;
    rmFxMessageId = "<" + rmFxMessageId.replace(new RegExp(/\"/g),"") + ">";
    // date   
    var dateStr =  msgHdr.date;
    var time = new Date();
    time.setTime(dateStr / 1000);		
   
    var timeString = reminderFox_mail_getTimeString( time );
    var dateVariableString;
    try {
        dateVariableString = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + 
				"." + REMINDER_FOX_LIST_DATE_LABEL);
    } catch(e) {
    }           
    var rmFxDate =reminderFox_getDateVariable( null, time, dateVariableString ) 
			+ "  " + timeString;

	var mInvitation = "     " +reminderFox_getBundle().getString("rf.add.mail.message.date") + ": " + rmFxDate + ret
					+ "     " +reminderFox_getBundle().getString("rf.add.mail.message.sender") + ": " + rmFxFrom + ret
					+ "     " +reminderFox_getBundle().getString("rf.add.mail.message.recipients") + ": " + rmFxTo + ret	;

	var _baseURI= this.content.document.body.baseURI
	var _content= this.content.document.body.textContent
	var _contentType= this.content.document.contentType
	var _documentURI= this.content.document.documentURI
	var _title= this.content.document.title
	if (currentAttachments.length > 0) { 			/* ----  check 'attachment(s)' for reminders  ---- */	
		var i=0;
		while (i < currentAttachments.length) {		
			if (   (currentAttachments[i].contentType == "text/calendar") 		/* 'normal apps */					
				|| (currentAttachments[i].contentType == "application/ics") /* Google Calendar */ 	
				||  currentAttachments[i].contentType == "application/octet-stream") { 	/* some calendars do not identify as calendar type */ 		
				var _contentType =	currentAttachments[i].contentType;
				var _url =	currentAttachments[i].url;
				var _name =	"iCalMsgAttachment"+i+".txt";
				var _uri =	currentAttachments[i].uri; 
		
				var temp = Components.classes["@mozilla.org/file/directory_service;1"]
							 .getService(Components.interfaces.nsIProperties)
							 .get("ProfD", Components.interfaces.nsIFile);
				
				var attfile = messenger.saveAttachmentToFolder(
					_contentType, _url, _name, _uri, temp); 
				
				setTimeout(rmFxGetiCalFromAttachment,500, mInvitation, attfile, _content);    
			}
			i++;
		}		
	}
	// otherwise if no attachments, see if they are contained in the body of the message
	else 	if (  _content.indexOf( "BEGIN:VEVENT") != -1 ) {
		rmFxGetiCalFromTextBody(_content, mInvitation);				
	}                     
}


function rmFxGetiCalFromAttachment(mInvitation, attfile, content) {  
	var reminderFoxEvents = new Array();
	var reminderFoxTodosArray = { };
	reminderFox_readInRemindersAndTodosICS(reminderFoxEvents, reminderFoxTodosArray, attfile, true);
	
	// check if we've successfully found any reminders or todo events		
	var foundEventsInAttachment = reminderFoxEvents.length != 0;
	if ( !foundEventsInAttachment ) {
		for ( var n in reminderFoxTodosArray ) {
			var importedTodos = reminderFoxTodosArray[n];
			if ( importedTodos.length > 0 ) {
				foundEventsInAttachment = true;
				break;
			}
		}
	}
	
	// if so, read-in from the attachment
	if ( foundEventsInAttachment ) {	
		rmFxGetiCalEvents( mInvitation, reminderFoxEvents, reminderFoxTodosArray );  
		} else {
		// otherwise, see if they are contained in the body
		if ( content.indexOf( "BEGIN:VEVENT") != -1 ) {
			rmFxGetiCalFromTextBody(content, mInvitation);	// 'body' of message
		}		
	}
	rmFx_msgTAGadd('i' + rmFx_iCalMETHOD, '#3333FF');	
}

function rmFx_iCalTest (){
/* ------------  test purpose only:  copy a BEGIN:CALENDAR ... END:CALENDAR 
                     to clipboard and call this function to process /simulate
                     an 'iCal import form email'
--------------- */                     
	var clip = Components.classes["@mozilla.org/widget/clipboard;1"]. 
	getService(Components.interfaces.nsIClipboard); 
	if (!clip) return false; 
	
	var trans = Components.classes["@mozilla.org/widget/transferable;1"]. 
		createInstance(Components.interfaces.nsITransferable); 
	if (!trans) return false; 
	trans.addDataFlavor("text/unicode");

	clip.getData(trans,clip.kGlobalClipboard); 
	var str = new Object(); 
	var strLength = new Object(); 
	trans.getTransferData("text/unicode",str,strLength);

	if (str) str = str.value.QueryInterface(Components.interfaces.nsISupportsString); 
	if (str) pastetext = str.data.substring(0,strLength.value / 2);

	var mInvitation = "[iCal] Schedule copied from Clipboard";
	this.reminderfox_Method ="CLIPBOARD";
	
	rmFxGetiCalFromTextBody(pastetext, mInvitation);
	
	return false;
}

function rmFxGetiCalFromTextBody(_content, mInvitation) {	
	var reminderFoxEvents = new Array();
	var reminderFoxTodosArray = { };
	
	reminderFox_readInRemindersAndTodosICSFromString(reminderFoxEvents, reminderFoxTodosArray, _content, true);
	
	rmFxGetiCalEvents( mInvitation,  reminderFoxEvents, reminderFoxTodosArray);
}

function rmFxGetiCalEvents( mInvitation, reminderFoxEvents, reminderFoxTodosArray, methodTyp) {
//gW  here we need to know the METHOD of the event
//  	with "send" 	it's set by processing before
// 		with "receive"	it's written to "this.reminderfox_Method"
	
	if (!!methodTyp) {
		rmFx_iCalMETHOD = methodTyp;
		} else {
		rmFx_iCalMETHOD = this.reminderfox_Method; 
	}
	// now iterate over each event and do special processing
	// get infos into reminder.notes ... depended of "METHOD"	
	for ( var i = 0; i < reminderFoxEvents.length; i++ ) {
		var reminder = reminderFoxEvents[i];	
		var result = reminderFox_processExtraScheduleInfo(reminder, mInvitation, rmFx_iCalMETHOD );
		if (result != "") {
			alert (result);
			return "";
		}
	}		

/* #1   handle multiple events; import them all with normal import
 */
    if (reminderFoxEvents.length >1) {   
    	
    	// prompt the user to import 	
    	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
	                    .getService(Components.interfaces.nsIPromptService);
    	var flags=promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 +
   			promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_1;     
		var msg = reminderFox_getBundle().getString("rf.mail.ical.import.overwrite.description");
		buttonPressed = promptService.confirmEx(window,reminderFox_getBundle().getString("rf.mail.ical.import.overwrite.title"),
		  msg,
		  flags,reminderFox_getBundle().getString("rf.button.ok"), reminderFox_getBundle().getString("rf.button.cancel"), null, null, {});		  
		  
		// cancel pressed
		if ( buttonPressed == 1 ) {	
			return "";
		}			

		reminderFox_addMultipleEvents(reminderFoxEvents, reminderFoxTodosArray);
    }     
    
//	#2  single Event/Schedule.  Add it via the "Add Reminder" entry dialog
//
    else if ( reminderFoxEvents.length == 1 ) { 	   	
		// check if 'new' Reminder. Result goes to ==> 'iCalSchedule'
	
		var rmFx_statusMsg="";  
		var reminder = reminderFoxEvents[0];	// the 'read' reminder
		var newExtra = rmFx_extraInfoArray(reminder);	// the 'extraInfo' items	
		
		var activeReminders = reminderFox_getReminderEvents();
	    
	// #2a 	loop with all reminders in  list and check if already in reminder.ics 
	    for (var nR =0; nR < activeReminders.length; nR++) {	
			if (reminder.id == activeReminders[nR].id ) { // reminder already known	
	        
				var oldExtra = rmFx_extraInfoArray(activeReminders[nR]);	
				var same  = (rmFx_extraInfo(newExtra,"DTSTAMP")) 
							== (rmFx_extraInfo(oldExtra,"DTSTAMP"))
							&& (rmFx_extraInfo(newExtra,"SEQUENCE")) 
							== (rmFx_extraInfo(oldExtra,"SEQUENCE"))	;		//++++2do  ++++2do  ++++2do  ++++2do  ++++2do  
																			//  check for oldSEQ > newSEQ  ==> ERR
				var older = (rmFx_extraInfo(newExtra,"DTSTAMP")) 
							<= (rmFx_extraInfo(oldExtra,"DTSTAMP"))
							|| (rmFx_extraInfo(newExtra,"SEQUENCE")) 
							 < (rmFx_extraInfo(oldExtra,"SEQUENCE"))	;		//++++2do  ++++2do  ++++2do  ++++2do  ++++2do  
																		//        for oldDTSTAMP > new ==> ERR
        
	        switch (rmFx_iCalMETHOD) {
	        case "REQUEST":  {
				// check if msg/reply was already processed 
				if  (same == true) {
					rmFx_statusMsg =  "[iCal  REQUEST] " + "\n\n" +mInvitation									
										+ "\n\n" + reminderFox_getBundle().getString("rf.schedule.attendee.processed");								
					alert (rmFx_statusMsg);
					return "";
				}
				if  (older == true) {
					rmFx_statusMsg =  "[iCal  REQUEST] " 	+ "\n" +mInvitation
								+     "\n\n" + reminderFox_getBundle().getString("rf.schedule.older1.processed")
								+       "\n" + reminderFox_getBundle().getString("rf.schedule.older2.processed")	;							
					alert (rmFx_statusMsg);
					return "";
				}				
	        	break;
	        }
	        
	        case "REPLY":  {	        	
				// check if msg/reply was already processed.
				// result on 'same' only doesn't say if the current 
				// processed msg was already processed.
				// So we check if a TAG 'ireply' is added to the msg.

				// this.currentHeaderData.tags.headerValue
				var msgHdr = gDBView.hdrForFirstSelectedMessage;
				var msgKeys = msgHdr.getStringProperty("keywords");
				if   ((same == true) && (msgKeys.indexOf("ireply") > -1)) {

					var msg =  "[REPLY] " + reminderFox_getBundle().getString("rf.schedule.attendee.processed")
								+ "\n\n" +mInvitation;					
					if (confirm(msg + "\n\n" + reminderFox_getBundle().getString("rf.schedule.processReply")) == false) {
						return "";
					}  
				}

				var attNo;
				var fromAttendee = rmFx_fromMailadr.substring(
							rmFx_fromMailadr.indexOf( "<" ) + 1,
							rmFx_fromMailadr.indexOf( ">" ));
				var fromATT = fromAttendee.toUpperCase();
				
				for ( var i = 0; i < rmFx_iCalAttendees.length; i++ ) {																
					if (rmFx_iCalAttendees[i].toUpperCase().indexOf(fromATT) > -1) attNo=i;
				}
  				// is the "from" address == the ATTENDEE ??, 
  				// if NOT  --> unknown CU ( + a "Party Crasher") ... 
				//	 So we have to ask the user which ATTENDEE has to be taken here
				if (rmFx_iCalAttendees[attNo] == null) {
					
					var results = { attendees:rmFx_iCalAttendees };
					window.openDialog("chrome://reminderfox/content/mail/rmFxReplyAttendees.xul",
					"rmFx-set-getReplyAttendee", "chrome,resizable,modal", results);        
					// CANCEL and not seleteced ==  -1
					// OK and selected == #
					if (results.attendeeNo == -1){
						return "";}
					
					var xx= rmFx_iCalAttendees[results.attendeeNo];
					
					var fndIndex = xx.toUpperCase().lastIndexOf( "MAILTO:" ); 
        			if (fndIndex == -1) { return ""};
            		var fromATT =  xx.substring( fndIndex + 7).toUpperCase();
				}
				// clone the stored event and update some items from
				// newEvent [REPLY] to oldEvent [the stored]
				//  - save the .notes
				var replyReminderNotes = reminder.notes;

				//  - ATTENDEE  grap the new 
				for ( var i = 0; i < newExtra.length; i++ ) {																
					if (newExtra[i].toUpperCase().indexOf(fromATT) > -1) var iNew=i;
				}
				for ( var i = 0; i < oldExtra.length; i++ ) {																
					if (oldExtra[i].toUpperCase().indexOf(fromATT) > -1) var iOld=i;
				}		
				oldExtra[iOld] = newExtra[iNew];

				// rebuild the extraInfo string
				for ( var i = 0; i < oldExtra.length; i++ ) {
					if (i==0) {activeReminders[nR].extraInfo = oldExtra[i];
					} else {
					activeReminders[nR].extraInfo += "\\n" + oldExtra[i];}
				}	

				reminder = activeReminders[nR];
				reminder.notes = replyReminderNotes
					+ "\n ____________ " + reminderFox_getBundle().getString("rf.schedule.previous") +  " ____________\n" 
					+ activeReminders[nR].notes;  
				break;				
			}	//METHOD:REPLY
			
			default: {//METHOD: ... all other (for the moment)									 		
		        //  get info from reminder 'in the list'  
		        
// ++edit## 
				var rSEQ = rmFx_extraInfo(activeReminders[nR],'sequence')
				var rDTSTAMPz = rmFx_extraInfo(activeReminders[nR],'dtstamp');
	           
				var rDTSTAMP = "";
				if (rDTSTAMPz != null ) {
			   	    rDTSTAMP= reminderFox_parseDateTimes(rDTSTAMPz) ;
				}
				//  get info from 'new' reminder        	           
				var nSEQ = rmFx_extraInfo(reminder,'sequence'); 
				var nDTSTAMPz = rmFx_extraInfo(reminder,'dtstamp');	   
			     
				var nDTSTAMP = "";
				if ( nDTSTAMPz != null ) {
			   		 nDTSTAMP =  reminderFox_parseDateTimes(nDTSTAMPz) ;
				}  
			
				var info1 = reminderFox_getBundle().getString("rf.reminder") + " [ " + activeReminders[nR].summary + " ] \n"
					+reminderFox_getBundle().getString("rf.schedule.check.summary")+ nR + "\n\n";  
			  
				var info2 =  "\n\nSEQUENCE\n    new:  #"     + nSEQ      + "     old: #" + rSEQ		
					+   "\nDTSTAMP \n     new:  [" + nDTSTAMP + "]     old:  [" + rDTSTAMP + "]";	
			
				if ((nSEQ *1) > (rSEQ*1)) { // new SEQUENCE should be greater
					rmFx_statusMsg = reminderFox_getBundle().getString("rf.schedule.new") + " '" + rmFx_iCalMETHOD + "' "
									+ " SEQUENCE" + " #" + nSEQ ;
			//      alert (info1  + rmFx_statusMsg +  info2) ;	                
				} else {	           	        		          
					if (nDTSTAMPz  <= rDTSTAMPz  ) {  	              
						rmFx_statusMsg = 'SEQUENCE / DTSTAMP' + reminderFox_getBundle().getString("rf.schedule.notValid");	
						alert (info1  + rmFx_statusMsg +  info2) ;
						return ""; 
						} else {      
						rmFx_statusMsg = reminderFox_getBundle().getString('rf.schedule.newDate') + '  [' + nDTSTAMP + ']';
					  	//              alert (info1  + rmFx_statusMsg +  info2) ;
					}
	            }    					

				if (rmFx_statusMsg != ""  && activeReminders[nR].notes != null)  {
					reminder.notes += "\n ____________ " + reminderFox_getBundle().getString("rf.schedule.previous") +  " ____________\n" + 
					activeReminders[nR].notes   
	    		}   		
			} // METHOD  ... all other
        	} // switch  
	    } // reminder already known	
	    } //#2a   -- loop with all reminders in  list 
		
		var ret = reminderFox_addReminderHeadlessly( reminder, true );
	
		return ret;
    }
    
    return "";
}

function reminderFox_processExtraScheduleInfo(reminder, mInvitation, rmFx_Method ) { 
/* 	here we prepare the reminder.notes   to reflect special schedule items 
 */ 
 	var msgReturn="";
 	
	if ( reminder.extraInfo == null ) return msgReturn;

//  here we need to know the METHOD of the event
 // 		it's written to "this.reminderfox_Method"  
 // 			eg.  REPLY, REQUEST, CANCEL, COUNTER, DECLINECOUNTER

	//var rmFx_iCalMETHOD = this.reminderfox_Method;	
			
	var addPerson = "";
	var addOption="";		var iSchComment = null;	var iSchStatus = null;  
	var nDTSTAMP;			var iSchStart;		var iSchEnd;    		

	var ret = "\n";	
	
	var extraInfos =  rmFx_extraInfoArray(reminder);
		
/*  'status'   goes to 'extraInfos' part of UI
	option = rmFx_extraInfo(extraInfos,"STATUS"); 
	if ( option != "" ) 
		iSchStatus =   option + ret;             
*/
		
	var nDTSTAMPz = rmFx_extraInfo(extraInfos,"DTSTAMP"); 
	if ( nDTSTAMPz != "" ) {
      	 nDTSTAMP  =  reminderFox_parseDateTimes(nDTSTAMPz) ;  
	}
	var nSEQ = rmFx_extraInfo(extraInfos,"SEQUENCE"); 
	
	option = rmFx_extraInfo(extraInfos,"COMMENT"); 
	if ( option != "" )
		iSchComment =  option + ret;             


	// next items go with  'addOption' to Notes
	
	var option = rmFx_extraInfo(extraInfos,"PRIORITY"); 
	if ( option != "" )
		addOption +=  "    " + "PRIORITY: " + option +  ret ;             

	option = rmFx_extraInfo(extraInfos,"CLASS"); 
	if ( option != null )
		addOption +=  "    " + "CLASS: " + option +  ret ;             
	
	option = rmFx_extraInfo(extraInfos,"CUTYPE"); 
	if ( option != null )
		addOption +=  "    " + "CUTYPE: " + option +  ret ;             

	option = rmFx_extraInfo(extraInfos,"TRANSP"); 
	if ( option != "" )
		addOption +=  "    " + "TRANSP: " + option +  ret ;             

	// ---->>  process PERSONS infos  ------
	var myMailAccounts = reminderFox_myMailAccounts("REPLY");
	         
	rmFx_iCalOrganizer = rmFx_extraInfo(extraInfos,"ORGANIZER", ";");
	
	// check if ORGANIZER is part of my accounts, 
	//    if METHOD:REPLY  it has to be! Else ERROR, don't add to reminder.ics
	
	if (rmFx_Method == "REPLY") {
		var fndIndex = rmFx_iCalOrganizer.toUpperCase().lastIndexOf( "MAILTO:" ); 
			if (fndIndex != -1) {
			var fndString = "<" + rmFx_iCalOrganizer.substring( fndIndex + 7) + ">";
			if (myMailAccounts.indexOf(fndString) == -1 ) {
				msgReturn = "[REPLY] " +reminderFox_getBundle().getString("rf.schedule.replyWrongOrganizer")
	    			+  ": \n" + fndString;
				return msgReturn;
			}
		}
	}  
  
    // get PARTSTAT for myAccount    
	var _Attendees = rmFx_extraInfo(extraInfos,"ATTENDEE", ";", true);  // true==read multiple entries
	var attPart ="";
	
	rmFx_iCalAttendees = _Attendees.split("\n");
	
	if (rmFx_iCalAttendees.length > 0  || nSEQ != null){
		for (var n=0; n<rmFx_iCalAttendees.length; n++){
			rmFx_iCalAttendees[n] = rmFx_iCalAttendees[n].toUpperCase();
			var fnd =  rmFx_iCalAttendees[n].lastIndexOf("MAILTO:");                        
			if (fnd != -1) {
				var address = rmFx_iCalAttendees[n].substring(fnd+7);
				if (address.indexOf(myMailAccounts)) {
                        
					fnd =  rmFx_iCalAttendees[n].indexOf("PARTSTAT=");
					if (fnd != -1) {
						var attPart = rmFx_iCalAttendees[n].substring(fnd+9);
						fnd = attPart.indexOf(";");
						if (fnd == -1) {attPart.indexOf(":")};
						var attPart = attPart.substring(0,fnd);	
					}
				}
			}
		}
		var wPART ="";
		if (rmFx_Method != "REQUEST") { var wPART = "  " + attPart; }
		var extraInfoSchedule = "[iCal] " + rmFx_Method + wPART + ": " + reminderFox_getBundle().getString("rf.schedule") ;	
		if ( nDTSTAMP != null && nDTSTAMP.length > 0 ) {
			extraInfoSchedule += " " + reminderFox_getBundle().getString("rf.schedule.asof") + "  " +nDTSTAMP;
		}
		if ( nSEQ != null ) {
			extraInfoSchedule += "    [# " + nSEQ + "]" + ret ;
		}
		extraInfoSchedule += mInvitation + ret;	
	}
	// <<<----  process PERSONS infos  ------

	 		
	switch (rmFx_Method) {
	case "REQUEST": 
	case "PUBLISH": {	// this is send to ATTENDEE(s), can be 
											// - new 
											// - revised 
	
			// ++++++++++++ Google Calendar Special  ++++++++++++
	 		if ( reminder.notes != null && reminder.notes.length > 0 ) {
				var iGMail = reminder.notes.toLowerCase().indexOf("http://www.google.com/calendar/event?action=view");
				if ( iGMail != -1) {
					var iGMail1 = reminder.notes.toLowerCase().indexOf(" ",iGMail);
					var httpGMail = reminder.notes.substring(iGMail,iGMail1);
					reminder.url = httpGMail;
				}
				// ++++++++++++ Google Calendar Special  ++++++++++++
	 		}
	 		
			if (addOption != null ) 
				extraInfoSchedule += "Options" +
				" ______________________" + ret + addOption + ret;	 		/* //extStr */

			if (iSchComment != null ) 									
				extraInfoSchedule += "Comment" +						
				" ______________________" + ret + iSchComment + ret;		/* //extStr */
		
	 		if ( reminder.notes != null && reminder.notes.length > 0 ) {
				reminder.notes = "> " + reminder.notes.replace(new RegExp(/\n/g),"\n>");
	 		}
	 		
	 		if (reminder.notes != null ) {								
				extraInfoSchedule +=	 "Description" +					
				"  ______________________" + ret 						
				+  reminder.notes	+ ret;											/* //extStr */
	 		} 
	 		  			
			// add category signifying that this is an invitation									
			var iCalCategory = reminderFox_getBundle().getString("rf.mail.ical.send.subject.invitation"); //   "invitation";  
			var iCalCategoryLC = iCalCategory.toLowerCase(); //   "invitation";  
			if ( reminder.categories != null && reminder.categories.length > 0 ) {
				if (reminder.categories.toLowerCase().indexOf(iCalCategoryLC) == -1){
					 reminder.categories = reminder.categories + ", " + iCalCategory;}
				}	else { reminder.categories = iCalCategory;
			}
			reminder.notes = extraInfoSchedule;	
			return msgReturn;
			break;					
		} //case:REQUEST" & "PUBLISH"

		case "REPLY": {	// this is send back to ORGANIZER 
			
			reminder.notes = extraInfoSchedule;	
			return msgReturn;
			break;					
		}	//case "REPLY"
	}	// switch (rmFx_Method)	
	return msgReturn;
}

    
function reminderFox_addMultipleEvents(reminderEvents, reminderTodos) {    
        // merge
	var existingEvents = reminderFox_getReminderEvents();
	var existingTodos = reminderFox_getReminderTodos();  //  ALL  todos
	reminderFox_mergeEvents(existingEvents, reminderEvents  );
	reminderFox_mergeTodos( existingTodos, reminderTodos );
 
	reminderFoxEvents = existingEvents;
	reminderFoxTodosArray = existingTodos;      
   
	reminderFox_importRemindersUpdateAll(false, null );   
}


//  ------------- SEND iCal ------------------------------

function reminderFox_getReminderEmailStoreFile() {
		var remindersToEmailFile =   reminderFox_getReminderStoreFile();
		remindersToEmailFile.leafName = "reminderfoxEvents.ics";
		var finalPath = remindersToEmailFile.path;
		
		var file2 = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		file2.initWithPath( finalPath );
		return file2;				
	}



function rmFx_sendAsItIs (reminder, organizer) { // send one or more 'reminder(s)'
//  ----- send them as they are as ICS data
	var methodTyp = "";	
	var attendees = null;
	var selectedTyp = "info";	

	// organizer
	if (organizer == "" || organizer == null) {organizer = rmFx_mailAppSetup();}									
	if (organizer == 'CANCEL') {return; }
	
	rmFx_sendEventNow(reminder, methodTyp, organizer, attendees, selectedTyp);		
}


function rmFxSendiCal (event) {
// ------ send a Mail with the selected Reminder as an INVITATION/SCHEDULE

	var selectedReminders="";
	var methodTyp = "PUBLISH";	 // default=PUBLISH ... other METHOD:PUBLISH, REQUEST, REPLY
	var attendees = null;
	var organizer = null;
	var selectedTyp = "invite";	
	var reminderTyp = "reminders";

	if (event.currentTarget.id == "treechildren-contextmenu-sendReminder") {
		selectedReminders = getAllSelectedReminders();		// from 'reminder list' context menu
		
		if (selectedReminders.length > 1) {
			rmFx_sendAsItIs (selectedReminders);				// we have >1 reminder, send them all
			return;
		}
		
	} else {
		selectedReminders = new Array();					// from 'icon' at 'Edit/Add dialog'
		selectedReminders[0] =this.arguments[0].reminder;
	}
	
	/*  have to check if the selected "Reminder" was already send as invitation/schedule;
	 *  that's the case if ORGANIZER is already included in "selectedReminders"
	*/				
		if (selectedReminders[0].extraInfo!= null) { 
			if (selectedReminders[0].extraInfo.indexOf("ORGANIZER") != -1) { 
				var msg = reminderFox_getBundle().getString("rf.schedule.wasSend") 
					+ "\n"   + reminderFox_getBundle().getString("rf.schedule.resendwithDialog")	
					+ "\n\n" + reminderFox_getBundle().getString("rf.schedule.sendAsEvent");
				
				if (confirm(msg) == false) {	
					var msg = 		reminderFox_getBundle().getString("rf.schedule.wantDelete")
						+ "\n\n"+ 	reminderFox_getBundle().getString("rf.schedule.okDelete");
					
					if (confirm(msg ) == true) {  // this is the 'delete invitation' part 
					
						var extraInfoArrayInv = rmFx_extraInfoArray(selectedReminders[0]);
						var extraInfoArray = new Array ();	var j=0;
						
						for (var i=0; i < extraInfoArrayInv.length; i++) {
							if (extraInfoArrayInv[i].indexOf("ORGANIZER")	> -1 ||
								extraInfoArrayInv[i].indexOf("ATTENDEE")	> -1 ||
								extraInfoArrayInv[i].indexOf("DTSTAMP")		> -1 ||
								extraInfoArrayInv[i].indexOf("STATUS")		> -1 ||
								extraInfoArrayInv[i].indexOf("CLASS")		> -1 ||
								extraInfoArrayInv[i].indexOf("COMMENT")		> -1 ||
								extraInfoArrayInv[i].indexOf("SEQUENCE")	> -1 )
								{ 
								} else {
								extraInfoArray[j] = extraInfoArrayInv[i]; j++;	
							}							
						}	
						// write the selectedReminder back to currentReminder without 'extra' strings					
						selectedReminders[0].extraInfo= extraInfoArray.join("\n");
						var reminderTodos=null;
						reminderFox_addMultipleEvents(selectedReminders, reminderTodos)
		
						alert (reminderFox_getBundle().getString("rf.schedule.hasDeleted")
							  + "\n\n" + reminderFox_getBundle().getString("rf.schedule.checkDeleted"));
					}
					return;
				} 
				selectedTyp ='info';  // was already send, don't allow to send as 'invite'
			}
		}

	// how to send Reminder(s): PUBLISH or REQUEST  ??  Get Attendee(s) and Comment
	//   if CANCEL pressed termninate
	var results = {	organizer: null, 
					attendees:null, 
					mode:null, 
					selectedTyp: selectedTyp,
					schComment: ""};
	window.openDialog("chrome://reminderfox/content/mail/invitation.xul",
            	"reminderFox-set-invitationmailAppString", "chrome,resizable,modal", results);        

	if (results.mode == 'CANCEL') { return;} // user pressed 'CANCEL'
	
	if (results.selectedTyp == "info") {
		// the selected 'reminder' is just a send "as-it-is" ===> PUBLISH
		rmFx_sendAsItIs (selectedReminders, results.organizer);
		return;
	}
	
	if (results.selectedTyp == "invite") {methodTyp = "REQUEST";}	
		         
	organizer = results.organizer;
	if (organizer == "") {
		alert (reminderFox_getBundle().getString("rf.schedule.organizer.required")
		+ "\n\n" + reminderFox_getBundle().getString("rf.schedule.organizer.mailAdr"));
		return;
	}	
	
	
// ++++++2do   ++++++2do   ++++++2do   ++++++2do   ++++++2do  
//    with NO attendees it's a PUBLISH



	if (results.attendees != null && results.attendees != "") {
		methodTyp = "REQUEST"; 		// attendees where entered --> REQUEST
		} else {							// if NOT --> hold default=PUBLISH
		methodTyp = "PUBLISH"; 	
	}
	//  add invitation info to 'extraInfo' item
	var originalReminder = selectedReminders[0];	
	var updatedReminder = reminderFox_cloneReminderFoxEvent(selectedReminders[0] );	

	if ( updatedReminder.extraInfo == null ) { 
		updatedReminder.extraInfo = "";
	}
	else {
		updatedReminder.extraInfo += "\\n";
	}
	
	var organizerName = organizer.split("<")[0];
	var organizerMail = organizer.split("<")[1];

	if (organizerMail == null) {
			organizerMail = organizerName;
			organizerName ="";
	}					 	
	if (organizerMail.charAt(organizerMail.length-1) == ">") {
		organizerMail = organizerMail.substring(0,organizerMail.length-1)
	}
	var xString ="ORGANIZER";
	if (organizerName != "") {xString += ";CN=" + organizerName}
	if (organizerMail != "") {xString += ":MAILTO:" + organizerMail}
	 	
	updatedReminder.extraInfo = updatedReminder.extraInfo +xString;
	
	// add SEQUENCE=1 and DTSTAMP (current date/time in 'Z'
	var currentDate = new Date();
	var tzOffset = new Date().getTimezoneOffset(); 
	currentDate.setMinutes( currentDate.getMinutes() + tzOffset );						
	 	
	var dtStamp = reminderFox_getDateAsString(currentDate)+ "Z";   
	updatedReminder.extraInfo += "\\nSEQUENCE:" + 1 +"\\nDTSTAMP:" + dtStamp;

	// add ATTENDEE(s)
    if (methodTyp == "REQUEST") {
    	attendees = results.attendees.replace(/(^\s+)|(\s+$)/g, '');       

		if ( updatedReminder.extraInfo == null ) { 
				updatedReminder.extraInfo = "";
		}  else {
				updatedReminder.extraInfo += "\\n";
		}
		//	ATTENDEE;RSVP=TRUE:MAILTO:abcde@fghi.xx 	 	
		var attendeeArray = attendees.split(",");
		for ( var i = 0; i < attendeeArray.length; i++  ) {
			if (attendeeArray[i] == "") {break;}     	 		
			var attendeeMail ="";
			var attendeeName ="";
				
			var attendeeX = attendeeArray[i].split("<");	     	 	
			if (attendeeX.length == 1) {	// only mailAdr
				var attendeeMail = attendeeX[0].replace(/(^\s+)|(\s+$)/g, '').replace(">", '');
			} else {						// mailName and adr
				var attendeeName = attendeeX[0].replace(/(^\s+)|(\s+$)/g, '');
			 	var attendeeMail = attendeeX[1].replace(/(^\s+)|(\s+$)/g, '').replace(">", '');
			}						
			var xString ="ATTENDEE";
			if (attendeeName != "") {xString += ";CN=" + attendeeName}
			if (attendeeMail != "") {xString += ";RSVP=TRUE;PARTSTAT=NEEDS-ACTION;ROLE=REQ-PARTICIPANT:MAILTO:" + attendeeMail}
				
			if ( i != 0 ) {
				updatedReminder.extraInfo += "\\n";
			}
			updatedReminder.extraInfo = updatedReminder.extraInfo + xString; 
		}
	}

	// add 'comment'  from invitation.xul dialog
	if (results.schComment != "") {
		updatedReminder.extraInfo += "\\nCOMMENT:" + results.schComment;
	}
	// add other items 
	reminderFox_processExtraScheduleInfo(updatedReminder, "", methodTyp );
	
	// add category 								
	var iCalCategory = reminderFox_getBundle().getString("rf.mail.ical.send.subject.invitation"); //   "invitation";  
	var iCalCategoryLC = iCalCategory.toLowerCase(); //   "invitation";  
	if ( updatedReminder.categories != null && updatedReminder.categories.length > 0 ) {
		if (updatedReminder.categories.toLowerCase().indexOf(iCalCategoryLC) == -1){
			 updatedReminder.categories = updatedReminder.categories + ", " + iCalCategory;}
			 
	} else { updatedReminder.categories = iCalCategory;
	}


//  REPLACE the current entry 
// -------	code from addReminderDialog.js  editReminder() ----------------
		removeListItemsForReminder(originalReminder); 
		// remove from model list
		var reminders = reminderFox_getReminderEvents();	
		for( var i = 0; i < reminders.length; i++) {
			if ( reminders[i].id == originalReminder.id ) {
				reminderFox_removeElement(reminders, i);
				break;
			}
		}

		// add reminder in sorted order...
		reminders = reminderFox_getReminderEvents();					
		if ( updatedReminder.remindUntilCompleted != REMINDERFOX_REMIND_UNTIL_COMPLETE_NONE ) {
 			updatedReminder.remindUntilCompleted = REMINDERFOX_REMIND_UNTIL_COMPLETE_TO_BE_MARKED;
 		}				
		var sortedIndex = reminderFox_getSortedIndexOfNewReminder( reminders, updatedReminder, false );
		reminderFox_insertIntoArray( reminders, updatedReminder, sortedIndex );
		
		updatedReminder.snoozeTime = null;  				
		createListItem(updatedReminder);			

		var currentDate = oeDatePicker.gSelectedDate;
		if ( currentDate == null ) {
			currentDate = new Date();
		}	

		var newDate = new Date();
		if ( updatedReminder.alarm != null ) {
			updatedReminder.alarmLastAcknowledge = newDate.getTime();
			// if there's a snooze... and lastack > snooze, erase snooze...  this means...  well it should be if date changed at all, then need to clear snooze...
		}
		updatedReminder.lastModified = reminderFox_getDateAsString(newDate );
		var reminder = reminderFox_processReminderDescription(updatedReminder,  currentDate.getFullYear(), false);		
		var modified = updateReminderInList( reminder );
		sortReminderIfNeccessary( updatedReminder.id);

		refreshCalendar();
		modifiedReminders();
// -------	code from addReminderDialog.js  editReminder() ----------------	

		selectedReminders[0] = updatedReminder;		// need array	
		rmFx_sendEventNow(selectedReminders, methodTyp, organizer, attendees, results.selectedTyp);
}


// splitted here to be called also from other places 
//  reminderToBeSend is passed as array!!
function rmFx_sendEventNow(reminderToBeSend, methodTyp, sendName, attendees, selectedTyp) { 
	
	var extraInfo = rmFx_extraInfoArray(reminderToBeSend[0]);
	
	var chunk = reminderFox_constructReminderOutput( reminderToBeSend, "", true, true, methodTyp );  	
    var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
          .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
    converter.charset = "UTF-8"; /* The character encoding you want, using UTF-8 here */
    
    var task = converter.ConvertFromUnicode(chunk);
    
// part 2  --------------	write ICS file

	var remindersToEmailFile = reminderFox_getReminderEmailStoreFile();
	var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
		.createInstance( Components.interfaces.nsIFileOutputStream );
	outputStream.init( remindersToEmailFile, 0x04 | 0x08 | 0x20, 420, 0 );
			
	outputStream.write(task, task.length);	
	outputStream.close(); 

   
/* part 3 --- sendEvent as attachment ------------------------------------
		3.0		setup up parameters for message
		3.1 	try to send using TB/SM internal routines. 
                    if this fails go for 
		3.2		FX with commandline option "-compose"
*/
// part 3.0 --- setup parameters for message ----------------- 

	var eMailSubject ="";

	if (methodTyp == "PUBLISH") {
	    eMailSubject = "[iCal] " + " " + methodTyp + ": ";
	}	
	if (methodTyp == "REQUEST" ) {
	    eMailSubject = "[iCal] " + " " + methodTyp + ": ";
	    selectedTyp = "invite";
	}    
	if (methodTyp == "REPLY") {
	    eMailSubject = "[iCal] " + " " + methodTyp;
	    selectedTyp = "invite";

	    var xAtt =rmFx_extraInfoArray(reminderToBeSend[0]);
	    var Item = "ATTENDEE";
	    var attPart="";
	    if (xAtt != null) {
		    if (xAtt.length > -1) {
				for (var n =0; n < xAtt.length; n++) {    
					if (xAtt[n].indexOf( Item )  == 0) {                        
						var fnd =  xAtt[n].indexOf("PARTSTAT=");
						if (fnd != -1) {
							var attPart = xAtt[n].substring(fnd+9);
							fnd = attPart.indexOf(";");
							if (fnd == -1) {attPart.indexOf(":")};
							var attPart = attPart.substring(0,fnd);	
						}
		            }
				}
		    }
	    }
    	eMailSubject +=  " " + attPart  + ": ";
    }  
	
	if (selectedTyp == "invite") {  // 'invite' was selected by invitation.xul dialog	
	    eMailSubject += reminderToBeSend[0].summary 
	        + " / " + reminderFox_getBundle().getString("rf.schedule.statusOf")
			+ " "   + reminderFox_parseDateTimes(rmFx_extraInfo(extraInfo,"DTSTAMP"))
			+ " [#" + rmFx_extraInfo(extraInfo,"SEQUENCE") +"]";
	} 
	if (selectedTyp == "info") {  // 'invite' was NOT selected by invitation.xul dialog	
		// differentiate:  1 event take the summary as subject
		if (reminderToBeSend.length == 1) {
		    eMailSubject += reminderToBeSend[0].summary; 
		} else {
		//                >1 events only give # of events
		    eMailSubject += reminderFox_getBundle().getString("rf.schedule.event.send") 
		    			+ " " + reminderToBeSend.length 
		    			+ " " + reminderFox_getBundle().getString("rf.schedule.event.send1") ;
		}
	}
	
	var otherString  = "";
	if (reminderToBeSend[0].location != null && reminderToBeSend[0].location != "") {          
		otherString = reminderFox_getBundle().getString("rf.mail.ical.send.location") 
			+ " " + reminderToBeSend[0].location + "\n"; 
    } 
    otherString += 
        "\n-- "  /* footer delimiter line !!! do not delete !  this notation will cut the following part from plain-text-reply !*/
        + "\n" +  
        "  ________________________________________________\n" +
        "  http://reminderfox.mozdev.org/\n";

// part 3.1  --------------try to send event as attachment (uses TB/SM internals)

	var nsIMsgCompFieldsComponent;
	var nsIMsgCompFields;
	var nsIMsgComposeParamsComponent;
	var nsIMsgComposeParams;
	var nsIMsgComposeServiceComponent;
	var nsIMsgComposeService;
	var nsIMsgCompFormat;
	var nsIMsgCompType;
	var nsIMsgAttachmentComponent;
	var nsIMsgAttachment;            

	try  // valid for TB / SM, otherwise go for FX (non-mail-apps)
	{
		
		// * The account manager is needed to get the default identity to send the mail out * /
		var AccountManagerComponent = Components.classes["@mozilla.org/messenger/account-manager;1"];
		var AccountManagerService = AccountManagerComponent.getService();
		var AccountManager = AccountManagerService.QueryInterface(Components.interfaces.nsIMsgAccountManager);
		var Account = AccountManager.defaultAccount;
		// Get the identities associated with this server.
		var id;
		var tempID;
		var identity = null;
		var identities = AccountManager.allIdentities;
 		var identitiesCount = identities.Count();
		for (id = 0; id < identitiesCount; ++id) {
			tempID = identities.GetElementAt(id).QueryInterface(Components.interfaces.nsIMsgIdentity);
			if (sendName.toLowerCase().indexOf(tempID.email.toLowerCase()) >= 0) {
				identity = tempID;
				break;
			}
		}

		// this opens the TB composer (header and mailbody predefined)
		try
		{	// attchment setup	   	
			nsIMsgAttachmentComponent = Components.classes["@mozilla.org/messengercompose/attachment;1"];
			nsIMsgAttachment = nsIMsgAttachmentComponent.createInstance(Components.interfaces.nsIMsgAttachment);
			nsIMsgAttachment.temporary 		= true;
			nsIMsgAttachment.name 			= remindersToEmailFile.leafName;
			nsIMsgAttachment.contentType 	= "text/calendar;"		

//	To make Outlook recognize it as a calnedar event .. 
// 	see http://twproject.blogspot.com/2007/04/integrate-your-java-agenda-and-ical.html		
// 		e.g.  "text/calendar;method=REQUEST;charset="UTF-8" 
//			nsIMsgAttachment.contentType 	= "text/calendar;method=" + methodTyp + ';charset="UTF-8"';		

//  +++2do  param will not be set with this .......
//  +++2do  further investigaing w. MIME handling for text/calendar content types required
//			http://wiki.mozilla.org/Calendar:ITIP_and_iMIP_Support 	

			
			nsIMsgAttachment.url 			= "file://" + remindersToEmailFile.persistentDescriptor;  
		  
			// mail header
			nsIMsgCompFieldsComponent = Components.classes["@mozilla.org/messengercompose/composefields;1"];
			nsIMsgCompFields = nsIMsgCompFieldsComponent.createInstance(Components.interfaces.nsIMsgCompFields);
			nsIMsgCompFields.useMultipartAlternative = true;
	   
			if (sendName == "") {sendName = Account.defaultIdentity.email;}
			
			nsIMsgCompFields.from 		= sendName;
			nsIMsgCompFields.replyTo 	= sendName;
			nsIMsgCompFields.subject 	= eMailSubject;			
			nsIMsgCompFields.to			= attendees;

			sendName = sendName.replace(new RegExp(/</g)," ");
			sendName = sendName.replace(new RegExp(/>/g)," ");
			
			nsIMsgCompFields.body = (reminderFox_getBundle().getString("rf.mail.ical.send.body") + "\n" 
 					+ "  "  + reminderFox_getBundle().getString("rf.mail.ical.send.sentBy") 
					+ "  "  + sendName +"\n"  + otherString);

			nsIMsgCompFields.addAttachment(nsIMsgAttachment);
			
			//      nsIMsgCompFields.attachVCard = true;
			//      nsIMsgCompFields.organization = gMailIdentity.organization;
		   
			// message paramaters
			nsIMsgComposeParamsComponent = Components.classes["@mozilla.org/messengercompose/composeparams;1"];
			nsIMsgComposeParams = nsIMsgComposeParamsComponent.
								createInstance(Components.interfaces.nsIMsgComposeParams);
			nsIMsgComposeParams.composeFields = nsIMsgCompFields;
			nsIMsgCompFormat = Components.interfaces.nsIMsgCompFormat;
			nsIMsgCompType = Components.interfaces.nsIMsgCompType;
			nsIMsgComposeParams.format = nsIMsgCompFormat.Default;
			nsIMsgComposeParams.type = nsIMsgCompType.New;
			nsIMsgComposeParams.identity=identity;
			
			// open a composer window
			nsIMsgComposeServiceComponent = Components.classes["@mozilla.org/messengercompose;1"];
			nsIMsgComposeService = nsIMsgComposeServiceComponent.getService().
								QueryInterface(Components.interfaces.nsIMsgComposeService);
			nsIMsgComposeService.OpenComposeWindowWithParams(null, nsIMsgComposeParams);
		}
		catch(ex) {
			var msgTxt = reminderFox_getBundle().getString("rf.schedule.mailFailed") + "\n\n" + 
				" Message : "	+ ex.message;
			alert(  msgTxt); 	
			reminderFox_logMessageLevel(msgTxt, 2);
			return;
		}
	
	} catch(e)   {
		/*  3.2  
			if above method fails we are in an non-mail-app (like FX), so we go for 
			"thunderbird.exe -compose "to='foo@nowhere.net,foo@foo.de',subject=cool page" .
			see http://www.mozilla.org/docs/command-line-args.html#Syntax_Rules
		   
			Remember some limitations here:
			   -- the composed msg can not be stored as draft / template
			   -- string in 'body' and 'subject' with '<' ... '>' are lost 
			   -- local characters like '.... cyrillic'  have to be convert to B64 ???
	               or it results in a string like :  '-./01234 cyrillic'
		*/	        
	    //	 get file object for 'mail' app 
        var mailAppPath = rmFx_mailSystemPath();
        if (mailAppPath == null)  { 
			alert (reminderFox_getBundle().getString("rf.schedule.mailNotFound"));
            return;
        }
 		var callingSeq =  "";
 		
 		if ( attendees != null ) {
 			callingSeq = "to='" + attendees +"',";     
 		}
 		callingSeq += "subject='"	+ eMailSubject  + "',"; 
		callingSeq += "body='"		+ reminderFox_getBundle().getString("rf.mail.ical.send.body");
		if ( sendName != null && sendName != "" ) {
			callingSeq = callingSeq + "\n  " + reminderFox_getBundle().getString("rf.mail.ical.send.sentBy")  
					+ " " + sendName;   
		}
		callingSeq = callingSeq +"\n  " + otherString +"',";
		callingSeq += "attachment='file:///" 	+ remindersToEmailFile.persistentDescriptor + "'";
		
        var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
                              .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
        converter.charset = "UTF-8";
        var chunk = null;
        try {
            chunk = converter.ConvertToUnicode(callingSeq);
        }
        catch( e ) {
            chunk = callingSeq;
        }
               
		var args = new Array();   
		args [0] = "-compose";
		args [1] = chunk;    //callingSeq;
        const   goProcess   = Components.classes["@mozilla.org/process/util;1"]
                                .createInstance(Components.interfaces.nsIProcess);                    
		goProcess.init(mailAppPath);
		goProcess.run(false, args, args.length);
	}    
}

function reminderFox_parseDateTimes(stringDT) { /*  20051208T224616  or  20051208T224616Z = UTC */
     var thisDate = reminderFox_getStringAsDate(stringDT);
     
    var timeString = reminderFox_mail_getTimeString( thisDate );
    var dateVariableString;
    try {
        dateVariableString = reminderFox_getUnicodePref(REMINDER_FOX_PREF + "." + REMINDER_FOX_LIST_DATE_LABEL);
    } catch(e) {
    }
    var remFoxDate =reminderFox_getDateVariable( null, thisDate, dateVariableString ) + "  " + timeString;
	return remFoxDate;
}

function rmFx_extraInfoArray(reminder){
/* ------ converts the extraInfo string to an array 
 */
	if  (!!reminder.extraInfo) {
		var extraInfoArray = reminder.extraInfo.split("\\n");	  
		return extraInfoArray;  
	} else {
		return null;
	}
}


function rmFx_extraInfo(extraInfos, item, delimiter, multiple){  // if multiple==true --> build array
// ------ reads from extraInfos array using item 
	if (delimiter == null) delimiter = ":";
	var Item = item.toUpperCase();
	var result="";
	if (extraInfos != null) {
		if (extraInfos.length > -1) {
			for (var n =0; n < extraInfos.length; n++) {
				if (extraInfos[n].indexOf( Item )  == 0) {
					if (multiple) {result +=  extraInfos[n].substring(extraInfos[n].indexOf( delimiter ) +1 ) + "\n"; 
					} else {
						result =  extraInfos[n].substring(extraInfos[n].indexOf( delimiter ) +1); 
						break;
					}
				}
			}
		}
	}
	return result;
}


//============================================================

// -------- select Attendee from menu -----------------

function rmFx_replyAttDialogClose() {
	window.arguments[0].attendeeNo = 
		document.getElementById('rmFx_replyAttendeeGroup').selectedIndex;
}        
function rmFx_replyAttDialogCancel() {
	window.arguments[0].attendeeNo = -1;
}        

function rmFx_replyAttendeeAdd() {
	var attendeesList = window.arguments[0].attendees;
	var attGroup = document.getElementById("rmFx_replyAttendeeGroup");
	for ( var i = 0; i < attendeesList.length; i++ ) {	
		
    	var fndIndex = attendeesList[i].toUpperCase().lastIndexOf( "MAILTO:" ); 
        if (fndIndex != -1) {
            var fndString =  attendeesList[i].substring( fndIndex + 7);
														
			var e = document.createElement("radio");
				e.setAttribute("group", "rmFx_replyAttendeeGroup");
				e.setAttribute("label", fndString);
			attGroup.appendChild(e);
        }
	}
}

// ---- setup 'mail-app' and 'myAccounts' ---- (for FX) ----
function rmFx_mailAppSetup() {

	var results = { organizer: null, attendees:null, 
		mode: "mailApp", 
		selectedTyp: "info",
		schComment: ""};
	window.openDialog("chrome://reminderfox/content/mail/invitation.xul",
            	"reminderFox-set-invitationmailAppString", "chrome,resizable,modal", results);        

	if (results.mode == 'CANCEL') { return 'CANCEL';} // user pressed 'CANCEL'

	return 	reminderFox_prefsBranch
				.getCharPref(REMINDER_FOX_MAIL_SENDER);
}


// ---- invitation XUL dialogs -------------
          
function rmFx_invitationLoadDialog() {
	
	if (window.arguments[0].mode == "mailApp") {
	 	this.title = reminderFox_getBundle().getString("rf.schedule.setDefaults");
	}

	var orgMenu= document.getElementById('organizerMenu');

	//  with reminderFox_myMailAccounts the mailAccounts/organizer 
	//  and the mailApplication location are checked and read
	
	var myAccount = reminderFox_myMailAccounts("loadInvitationDialog");
	if (!!myAccount) {
		var myAccounts = myAccount.split(",");
		for (var i = 0; i < myAccounts.length; i++) {
		     var myAccount = myAccounts[i];
			 var menuitem = orgMenu.appendItem(myAccount, i);
		}
		orgMenu.selectedIndex = 0;
	}
 	document.getElementById('reminderFox-mailApp.Location-Box')
			.setAttribute( "hidden", rmFx_mailApplication );

 	document.getElementById('mailApp.location.input').value = 
 		rmFx_mailSystemPath().persistentDescriptor;

	rmFx_invitationSwitch();
}	


function rmFx_invitationCloseDialog(mode) {  // mode = CANCEL or OK
	var organizer = document.getElementById('organizerMenu').label;
	reminderFox_prefsBranch.setCharPref
		(REMINDER_FOX_MAIL_SENDER,organizer);
	
	window.arguments[0].organizer = organizer;
	window.arguments[0].mode = mode;


	if (document.getElementById('inviteEnable').checked == true) {
		window.arguments[0].selectedTyp = 'invite';		
		window.arguments[0].attendees = document.getElementById('attendees').value;
	} else {
		window.arguments[0].selectedTyp = 'info';
		window.arguments[0].attendees = "";
	}
	if ( document.getElementById('commentCheck').checked ==  true 
		 && document.getElementById('commentText').value != "") {
		window.arguments[0].schComment  = document.getElementById('commentText').value;
	}else {
		window.arguments[0].schComment  = "";
	} 
	var location = document.getElementById('mailApp.location.input').value
	reminderFox_prefsBranch.setCharPref
    	(REMINDER_FOX_MAIL_PATH,location);
}         
            
function rmFx_invitationSwitch() {
	if (window.arguments[0].selectedTyp == 'info') {
				
		document.getElementById('reminderFox-invitationGroup')
			.setAttribute( "hidden", true );
		document.getElementById('reminderFox-commentGroup')
			.setAttribute( "hidden", true );
		return;} 
	
	// if 'attendee' checked, than 'send as invitation/schedule' == seletedTyp='invite'
	// ... then also enable the 'comment'
		
	if ( document.getElementById('inviteEnable').checked ==  true ) {
		document.getElementById('attendees').removeAttribute( "disabled");
		document.getElementById('reminderFox-commentGroup')
					.setAttribute( "hidden", false );
		document.getElementById('reminderFox-attendeeGroup')
					.setAttribute( "hidden", false );
	}
	
	if ( document.getElementById('inviteEnable').checked ==  false ) {
		document.getElementById('attendees').setAttribute( "disabled", true );
		document.getElementById('reminderFox-commentGroup')
			.setAttribute( "hidden", true );
		document.getElementById('reminderFox-attendeeGroup')
			.setAttribute( "hidden", true );			
	}

	sizeToContent();
}

function reminderFox_commentSwitch() {
	if ( document.getElementById('commentCheck').checked ==  false ) {
		document.getElementById('commentEntry').setAttribute( "hidden", true );
	}
	else {
		document.getElementById('commentEntry').removeAttribute( "hidden", false);
	}	
	sizeToContent();
}

// --------- functions for TB,SM   ... and 'non' mail (like FX)  ---------

function reminderFox_myMailAccounts(aMsg) {
/*			with TB directly from	mail.accountmanager.accounts
 *			with FX use				FXprefs = extensions.reminderFox.mail.sender
 */
	try {     // OK: if we are in 'mail' system (TB, SM)
		var _prefs = Components.classes["@mozilla.org/preferences-service;1"].
	            getService(Components.interfaces.nsIPrefBranch);	
		var accounts = _prefs.getCharPref("mail.accountmanager.accounts");
	   	var myAccounts=""; 

		if (accounts) {
		    var accountsArray = accounts.split(",");   
		/*	"mail.account.account1.identities", "id1");
			"mail.identity.id1.fullName", "gWahl");
			"mail.identity.id1.useremail", "guenter@abc.xx");    
		 */   
		    for (var x = 0; x < accountsArray.length; x++) {
			    try {
				    var temp1 = _prefs.getCharPref("mail.account." + accountsArray[x] + ".identities");
			 	    var temp2 = _prefs.getCharPref("mail.identity." + temp1 + ".useremail");
			 	    var temp3 = _prefs.getCharPref("mail.identity." + temp1 + ".fullName");
			        myAccounts +=  temp3+"<" + temp2 + ">,";
				} catch ( e ) {  }
			}
			myAccounts = myAccounts.substring(0,myAccounts.length-1);
		}
		//   write the myAccounts  to the prefs 
		reminderFox_prefsBranch.setCharPref
			(REMINDER_FOX_MAIL_SENDER,myAccounts);
		rmFx_mailApplication = true;
	}
	catch (ex) {
		rmFx_mailApplication = false;
		try {
			var myAccounts = reminderFox_prefsBranch.getCharPref
			( REMINDER_FOX_MAIL_SENDER );
			} catch (e) {}
	}
	return myAccounts;
}

/*		
Firefox {ec8030f7-c20a-464f-9b0e-13a3a9e97384}
Thunderbird	{3550f703-e582-4d05-9a08-453d09bdfdc6}
Nvu {136c295a-4a5a-41cf-bf24-5cee526720d5}
Mozilla Suite {86c18b42-e466-45a9-ae7a-9b95ba6f5640}
SeaMonkey {92650c4d-4b8e-4d2a-b7eb-24ecf4f6b63a}
Sunbird {718e30fb-e89b-41dd-9da7-e25a45638b28}
Netscape Browser {3db10fab-e461-4c80-8b97-957ad5f8ea47}
Flock Browser {a463f10c-3994-11da-9945-000d60ca027b}	
*/

// ----- get the  mail apps string 	needed for the 'MailSystemPath' as file object

function rmFx_mailSystemPath(){
/* 		  -- first check prefs
 		  -- than make an estimate (normal WIN installation location)
 */
    var	file = Components.classes["@mozilla.org/file/local;1"]
                .createInstance(Components.interfaces.nsILocalFile);
    try { 
    	filePath = reminderFox_prefsBranch.getCharPref
    		( REMINDER_FOX_MAIL_PATH );
    }
    catch ( e ) {	
		var appNameX =Components.classes["@mozilla.org/xre/app-info;1"]
		var appName = appNameX.getService(Components.interfaces.nsIXULAppInfo).name
		var appID = appNameX.getService(Components.interfaces.nsIXULAppInfo).ID
		
			// TB or SM ??  ... more 'mail' apps ????
		if ((appID == REMINDERFOX_THUNDERBIRD_ID) || 
			(appID == REMINDERFOX_SEAMONKEY_ID)) {		
			var mfile = Components.classes["@mozilla.org/file/directory_service;1"]
				.getService(Components.interfaces.nsIProperties)
				.get("CurProcD", Components.interfaces.nsIFile);
				
	        var filePath = mfile.parent.path + "\\" + mfile.leafName 
	        	+"\\" + appName + ".exe"; 						
		} else {  // NOK, return 'best' estimate  .. at least for window
		
		//	filePath = "C:\\Programme\\Mozilla Thunderbird\\thunderbird.exe";		
			filePath = reminderFox_getBundle().getString("rf.mailpath");
		}		
 	}
	try {
		file.initWithPath(filePath);
    	var fileValid = file.exists(); 
		if  (fileValid == false) {
			alert (reminderFox_getBundle().getString("rf.schedule.mailBrowse"));
			return "";
		} else {
		    reminderFox_prefsBranch.setCharPref
		    	(REMINDER_FOX_MAIL_PATH, filePath);
		}
	} catch (e) {
			alert (reminderFox_getBundle().getString("rf.schedule.mailBrowse"));
			return "";
	}

	return file;  // return file object
}

// ------------  "Browse" for 'mail' path -------------------

function rmFx_mailAppStringBrowse () { 
    const nsIFilePicker = Components.interfaces.nsIFilePicker;  
    var fp = Components.classes["@mozilla.org/filepicker;1"]
                   .createInstance(nsIFilePicker);
    fp.init(window, "'Mail' Application Location Search", nsIFilePicker.modeOpen);
    fp.appendFilter("'Mail' System", "*.exe");
    
    var rv = fp.show();
    if (rv == nsIFilePicker.returnOK)  {
        var file = fp.file;

 		document.getElementById('mailApp.location.input').value = file.persistentDescriptor;
	    reminderFox_prefsBranch.setCharPref
    		(REMINDER_FOX_MAIL_PATH, file.persistentDescriptor);
     }  
     else  {
        reminderFox_prefsBranch.setCharPref
        	(REMINDER_FOX_MAIL_PATH, "");        		
     }
}

// -------------- open 'mail' addressbook ------------------

function rmFx_abookOpen() {
	
	// first enable textbox for easy pasting
	document.getElementById('attendees').removeAttribute( "disabled");
	document.getElementById('inviteEnable').setAttribute( "checked","true");

	const nsIWindowMediator = Components.interfaces.nsIWindowMediator;
	var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	var	windowManagerInterface = windowManager.QueryInterface(nsIWindowMediator);

	var	inType	=	"mail:addressbook";
	var topWindow = windowManagerInterface.getMostRecentWindow( inType );
	
	if ( topWindow ) {	// if already open bring it to front
		topWindow.focus();
	} else {	      	
        var mailAppPath = rmFx_mailSystemPath();
        if (mailAppPath == null)  { 
			alert (reminderFox_getBundle().getString("rf.schedule.abNotFound"));
            return;
        }
	    var theProcess = Components.classes["@mozilla.org/process/util;1"]
	                        .createInstance(Components.interfaces.nsIProcess);        
	    theProcess.init(mailAppPath);
	    theProcess.run(false, new Array( "-addressbook"), 1);
	}
}

function rmFx_abookMini() {
	var	inType	=	"mail:addressbook";

	const nsIWindowMediator = Components.interfaces.nsIWindowMediator;
	var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	var	windowManagerInterface = windowManager.QueryInterface(nsIWindowMediator);
	var topWindow = windowManagerInterface.getMostRecentWindow( inType );

    topWindow.minimize();
}

function rmFx_insertAttendees(xAttendees) {
// focus on the  'invitation' window
	var	inType	=	"window:ItemDialog";

	const nsIWindowMediator = Components.interfaces.nsIWindowMediator;
	var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	var	windowManagerInterface = windowManager.QueryInterface(nsIWindowMediator);
	var topWindow = windowManagerInterface.getMostRecentWindow( inType );

	try {
		topWindow.focus();
		var attendeeBox = topWindow.document.getElementById("attendees");
		var attendeeText = attendeeBox.value;
		var end0 = attendeeBox.selectionEnd; 

		if (attendeeText == "" && attendeeText != null){
			attendeeBox.value = xAttendees;
		}
		else {
			if (attendeeText.charAt(attendeeText.length) != ',') {
				attendeeBox.value = attendeeText + ',' + xAttendees;
			} else {
				attendeeBox.value = attendeeText + xAttendees;
			}
		}
		var end = attendeeBox.textLength;
		attendeeBox.setSelectionRange(end);
		topWindow.focus();
	} catch (e) {}
}
  
// http://tools.ietf.org/html/rfc2446#section-3.2.2.1 Rescheduling an Event
function rmFx_iCalReschedule(originalReminder, currentReminder) {
// ---------------------------------------------------------------	
	if (originalReminder.extraInfo == null) return;
	
	var extraInfoOrginal = rmFx_extraInfoArray (originalReminder);
	var extraInfoCurrent = rmFx_extraInfoArray (currentReminder);
	
	var currentATT = rmFx_extraInfo( extraInfoOrginal,"ATTENDEE"); 
	if (currentATT == null || currentATT.length == 0)  { return;}  
	// OK  it's a Invitation/Schedule .. rescheduling requirements:
	// 		1. is the ORGANIZER one of my accounts?  Maybe hard with FX!!
	// 		2.  A rescheduled event involves time or recurrence intervals 
	//     		and possibly the location or description 
	
  // ad 1.  check ORGANIZER
	// currentORG[0] =   "ORGANIZER;CN=name:MAILTO:mailadr@abc.xx"
	// myAccounts    =   "name<mailadr@xyz.xx>,name2<mailadr2@mmm.zz>"

	var currentORG = rmFx_extraInfo( extraInfoOrginal,"ORGANIZER");
	if (currentORG.length == 0)  { return;}  // no ORGANIZER
	var fndIndex = currentORG[0].toUpperCase().lastIndexOf( "MAILTO:" ); 

	if (reminderFox_myMailAccounts().toUpperCase().indexOf(currentORG[0]
		.substring( fndIndex + 7).toUpperCase()) == -1 ) {return;} // no ORGANIZER -- no Invitation/Schedule
  	// ORGANIZER ok
  		
  // ad 2. check if parameters changed 	

	if (currentReminder.endDate == null  && originalReminder.endDate != null) {
		currentReminder.endDate = originalReminder.endDate;
	}	

	var dateChange   = originalReminder.date.toGMTString()
                     != currentReminder.date.toGMTString()
                 ||     originalReminder.endDate.toGMTString()
                     != currentReminder.endDate.toGMTString();
	var recurChange	= ( 
		  	originalReminder.recurrence.byDay 	 != currentReminder.recurrence.byDay
		||	originalReminder.recurrence.endDate  != currentReminder.recurrence.endDate
		||	originalReminder.recurrence.interval != currentReminder.recurrence.interval
		||	originalReminder.recurrence.type 	 != currentReminder.recurrence.type);
	var sumChange	= originalReminder.summary != currentReminder.summary;

	if ( !(dateChange || recurChange || sumChange ) ) {return;}  // no Change

  //  ORGANIZER 'rescheduled' the event   
  //   read ORGANIZER   from reminder and set it to 'sendName'	
  //   read ATTENDEE(s) from reminder and set it to 'attendees'	
  //   parameter to be updated:
  //   - DTSTAMP
  //   - SEQUENCE
  //   - SUMMARY/DESCRIPTION
  //   - LASTMODIFIED ????
	
	var sendName = currentORG[0].substring( fndIndex + 7);
	var aExtraInfo  = rmFx_extraInfoArray(currentReminder);

	// for ATTENDEE(s) have to build the to=mailString and all ATT need to called RSVP!!

	var attendeeString ="";		// for iCal ATTENDEE:
	var attendees ="";			// for mail compose to=
	
	for (var i=0; i< aExtraInfo.length; i++) {
		if (aExtraInfo[i].indexOf("ATTENDEE") == 0) {
			
			var attendeeName="";
			var attendeeMail="";
			var fndIndex = aExtraInfo[i].toUpperCase().lastIndexOf( "MAILTO:");  
	        if (fndIndex != -1) {
	            attendeeMail = aExtraInfo[i].substring( fndIndex + 7);          
	        } else {
				var colnIndex = aExtraInfo[i].lastIndexOf(":");
				if (colnIndex != -1) {
					if 	(aExtraInfo[i].substring( colnIndex).indexOf("@") != -1) {
						attendeeMail = aExtraInfo[i].substring( colnIndex + 1);  }
				}   
			}     
	        var fndIndex = aExtraInfo[i].toUpperCase().indexOf( "CN=" ); 
	        if (fndIndex != -1) {
				var fndString = aExtraInfo[i].substring( fndIndex + 3);
				var colnIndex = fndString.indexOf(":");
				var semkiIndex = fndString.indexOf(";");
				
				if ((semkiIndex != -1) && (semkiIndex < colnIndex))  {
					attendeeName = fndString.substring( 0, semkiIndex);       
				} else {attendeeName = fndString.substring( 0, colnIndex);  }
	        }
			if (attendeeName == "") {attendees +=  '<' + attendeeMail +'>,';
				} else {
				attendees += attendeeName + '<' + attendeeMail +'>,';
			}
			var attendeeString ="ATTENDEE";		
			if (attendeeName != "") {attendeeString += ";CN=" + attendeeName}
			if (attendeeMail != "") {attendeeString += ";RSVP=TRUE;PARTSTAT=NEEDS-ACTION;ROLE=REQ-PARTICIPANT:MAILTO:" + attendeeMail}
			aExtraInfo[i] = attendeeString;
		}
	}
	rmFx_extraInfoReplace (aExtraInfo, "SEQUENCE", rmFx_extraInfo(aExtraInfo, "SEQUENCE")*1 + 1);
	rmFx_extraInfoReplace (aExtraInfo, "DTSTAMP", rmFx_setDateTimeZ());
	rmFx_extraInfoReplace (aExtraInfo, "COMMENT", "");		// erase oldy
	
	currentReminder.extraInfo = aExtraInfo.join("\\n");
	// delete double 'CR'
	currentReminder.extraInfo = currentReminder.extraInfo.replace(new RegExp(/\\n\\n/g),"\\n");


	var chText = (dateChange ? "Date/Time ":"") + (recurChange ? "Recurrance ":"") + (sumChange ?"Title":"");
		
	var methodTyp = "REQUEST";
	var newNotes = "[iCal] " + methodTyp + ": " + reminderFox_getBundle().getString("rf.schedule.statusOf")
		+ reminderFox_parseDateTimes(rmFx_extraInfo(aExtraInfo,"DTSTAMP"))
		+ " [#" + rmFx_extraInfo(aExtraInfo,"SEQUENCE") +"]\n"
		+ "Invitation/Schedule changed: " + chText +"\n\n";							/* //extStr */
	
	currentReminder.notes = newNotes + currentReminder.notes
	var reminders = new Array();
	reminders[0] = currentReminder;
	var iCalInvite = true;
	rmFx_sendEventNow(reminders, methodTyp, sendName, attendees, iCalInvite); 
}

function rmFx_inviteStatus(currentReminder) {
// --------------------------------------------	
//	var extraInfoOrginal = rmFx_extraInfoArray (currentReminder);

	var currentORG = rmFx_extraInfo( rmFx_extraInfoArray (currentReminder),"ORGANIZER");	
	if (currentORG.length == 0)  { return;}  // no ORGANIZER

	var fndIndex = currentORG[0].toUpperCase().lastIndexOf( "MAILTO:" ); 
	if (reminderFox_myMailAccounts().toUpperCase()
		.indexOf(currentORG[0].substring( fndIndex + 7).toUpperCase()) == -1) {
		
			document.getElementById("newReminderText").setAttribute("disabled", "true");	
			
			document.getElementById("reminderFox-all-day").setAttribute("disabled", "true");	

			document.getElementById("reminderFox-timeList").setAttribute("disabled", "true");	
			document.getElementById("yearlist").setAttribute("disabled", "true");	
			document.getElementById("monthlist").setAttribute("disabled", "true");	
			document.getElementById("daylist").setAttribute("disabled", "true");
			
			document.getElementById("reminderFox-endTimeList").setAttribute("disabled", "true");	
			document.getElementById("endyearlist").setAttribute("disabled", "true");	
			document.getElementById("endmonthlist").setAttribute("disabled", "true");	
			document.getElementById("enddaylist").setAttribute("disabled", "true");	

			document.getElementById("datepickerToggle").setAttribute("disabled", "true");
			document.getElementById("datepickerEndToggle").setAttribute("disabled", "true");

			document.getElementById("location").setAttribute("disabled", "true");
			document.getElementById("reminderFox-repeat").setAttribute("disabled", "true");
	}
}

function rmFx_extraInfoReplace (extraInfo, itemName, itemValue) {
// ------ writes to aExtraInfo array using item 
    itemName = itemName.toUpperCase();
    var result="";
    if (extraInfo != null) {
	    if (extraInfo.length > -1) {
			for (var n =0; n < extraInfo.length; n++) {    
				if (extraInfo[n].indexOf( itemName )  == 0) { 
					if  (itemValue == "") {
						extraInfo[n] ="";
						break;
					}                  
		        	extraInfo[n] = itemName + ":" + itemValue;
		        	break
	            }
			}
	    }
    }  	
}


function rmFx_setDateTimeZ() {	
	var currentDate = new Date();
	var tzOffset = new Date().getTimezoneOffset(); 
	currentDate.setMinutes( currentDate.getMinutes() + tzOffset );						
	 	
	return  reminderFox_getDateAsString(currentDate)+ "Z";   
}
	